# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['UserRoleGrantsArgs', 'UserRoleGrants']

@pulumi.input_type
class UserRoleGrantsArgs:
    def __init__(__self__, *,
                 roles: pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]],
                 user_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a UserRoleGrants resource.
        :param pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]] roles: The list of roles to include. ORG_MEMBER must be included.
        :param pulumi.Input[str] user_id: ID of the user to grant these roles to.
        """
        pulumi.set(__self__, "roles", roles)
        pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def roles(self) -> pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]]:
        """
        The list of roles to include. ORG_MEMBER must be included.
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]]):
        pulumi.set(self, "roles", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Input[str]:
        """
        ID of the user to grant these roles to.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "user_id", value)


@pulumi.input_type
class _UserRoleGrantsState:
    def __init__(__self__, *,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UserRoleGrants resources.
        :param pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]] roles: The list of roles to include. ORG_MEMBER must be included.
        :param pulumi.Input[str] user_id: ID of the user to grant these roles to.
        """
        if roles is not None:
            pulumi.set(__self__, "roles", roles)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]]]:
        """
        The list of roles to include. ORG_MEMBER must be included.
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['UserRoleGrantsRoleArgs']]]]):
        pulumi.set(self, "roles", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the user to grant these roles to.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)


class UserRoleGrants(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[Union['UserRoleGrantsRoleArgs', 'UserRoleGrantsRoleArgsDict']]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ## Import

        format: <user id>

        ```sh
        $ pulumi import cockroach:index/userRoleGrants:UserRoleGrants service_account 1f69fdd2-600a-4cfc-a9ba-16995df0d77d
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['UserRoleGrantsRoleArgs', 'UserRoleGrantsRoleArgsDict']]]] roles: The list of roles to include. ORG_MEMBER must be included.
        :param pulumi.Input[str] user_id: ID of the user to grant these roles to.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UserRoleGrantsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ## Import

        format: <user id>

        ```sh
        $ pulumi import cockroach:index/userRoleGrants:UserRoleGrants service_account 1f69fdd2-600a-4cfc-a9ba-16995df0d77d
        ```

        :param str resource_name: The name of the resource.
        :param UserRoleGrantsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UserRoleGrantsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[Union['UserRoleGrantsRoleArgs', 'UserRoleGrantsRoleArgsDict']]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UserRoleGrantsArgs.__new__(UserRoleGrantsArgs)

            if roles is None and not opts.urn:
                raise TypeError("Missing required property 'roles'")
            __props__.__dict__["roles"] = roles
            if user_id is None and not opts.urn:
                raise TypeError("Missing required property 'user_id'")
            __props__.__dict__["user_id"] = user_id
        super(UserRoleGrants, __self__).__init__(
            'cockroach:index/userRoleGrants:UserRoleGrants',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            roles: Optional[pulumi.Input[Sequence[pulumi.Input[Union['UserRoleGrantsRoleArgs', 'UserRoleGrantsRoleArgsDict']]]]] = None,
            user_id: Optional[pulumi.Input[str]] = None) -> 'UserRoleGrants':
        """
        Get an existing UserRoleGrants resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['UserRoleGrantsRoleArgs', 'UserRoleGrantsRoleArgsDict']]]] roles: The list of roles to include. ORG_MEMBER must be included.
        :param pulumi.Input[str] user_id: ID of the user to grant these roles to.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UserRoleGrantsState.__new__(_UserRoleGrantsState)

        __props__.__dict__["roles"] = roles
        __props__.__dict__["user_id"] = user_id
        return UserRoleGrants(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def roles(self) -> pulumi.Output[Sequence['outputs.UserRoleGrantsRole']]:
        """
        The list of roles to include. ORG_MEMBER must be included.
        """
        return pulumi.get(self, "roles")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Output[str]:
        """
        ID of the user to grant these roles to.
        """
        return pulumi.get(self, "user_id")

